/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.browsing.ui.graph.contributor.viewpoint;

import java.util.Collection;

import org.simantics.browsing.ui.BuiltinKeys;
import org.simantics.browsing.ui.NodeContext;
import org.simantics.browsing.ui.graph.impl.contributor.viewpoint.ViewpointContributorImpl;
import org.simantics.db.ReadGraph;
import org.simantics.db.exception.DatabaseException;

/**
 * @param <T> defines the type of input a contributor can handle. Only if the
 *        {@link NodeContext} {@link BuiltinKeys#INPUT} constants is an instance
 *        of this class will this contributor be invoked.
 */
abstract public class ViewpointContributor<T> extends ViewpointContributorImpl<T> {

	public static final String STANDARD = "Standard";
	
    @Override
    abstract public Collection<?> getContribution(ReadGraph graph, T input) throws DatabaseException;

	@Override
	public String getViewpointId() {
		return STANDARD;
	}
	
}